#define LIGHT_SENSOR_PIN 34
#define SOUND_SENSOR_PIN 35
#define RED 25
#define GREEN 26
#define BLUE 27
#define BUZZER_PIN 12

#define BLYNK_TEMPLATE_ID "*********"
#define BLYNK_TEMPLATE_NAME "*********"
#define BLYNK_AUTH_TOKEN "*********"

#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978
#define REST      0

#include <WiFi.h>
#include <WiFiClient.h>
#include <BlynkSimpleEsp32.h>

// Wi-Fi credentials
char ssid[] = "*******";
char password[] = "*****";

const int virtualPin = V1;
const int virtualPinSound = V2;

int isMusic = 0;


int melody[] = {
  NOTE_G4, 4, NOTE_G4, 4, //1
  NOTE_AS4, -4, NOTE_G4, 8, NOTE_G4, 4,
  NOTE_AS4, 4, REST, 4, NOTE_G4, 8, NOTE_AS4, 8,
  NOTE_DS5, 4, NOTE_D5, -4, NOTE_C5, 8,
  NOTE_C5, 4, NOTE_AS4, 4, NOTE_F4, 8, NOTE_G4, 8,
  NOTE_GS4, 4, NOTE_F4, 4, NOTE_F4, 8, NOTE_G4, 8,
  NOTE_GS4, 4, REST, 4, NOTE_F4, 8, NOTE_GS4, 8,
  NOTE_D5, 8, NOTE_C5, 8, NOTE_AS4, 4, NOTE_D5, 4,

  NOTE_DS5, 4, REST, 4
};

const int tempo = 90;
int notes = sizeof(melody) / sizeof(melody[0]) / 2;
int divider = 0, noteDuration = 0;
int wholenote = (60000 * 4) / tempo;

BLYNK_WRITE(V3)
{
  int pinValue = param.asInt();
  analogWrite(RED, pinValue);
}

BLYNK_WRITE(V4)
{
  int pinValue = param.asInt();
  analogWrite(GREEN, pinValue);
}

BLYNK_WRITE(V5)
{
  int pinValue = param.asInt();
  analogWrite(BLUE, pinValue);
}

BLYNK_WRITE(V9)
{
  int pinValue = param.asInt();
  if (pinValue == 1) {
    music();
  } 
}

void music() {
  isMusic = 1;
  for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {
    if (thisNote % 3 == 0) {
        color_red();
        color_green();
        color_blue();
        color_purple();
        color_light_green();
        color_light_blue();
        color_red();
    }
    else if (thisNote % 3 == 1) {
        color_purple();
        color_light_green();
        color_light_blue();
        color_red();
        color_green();
        color_blue();
        color_green();
    }
    else if (thisNote % 3 == 2) {
        color_light_green();
        color_light_blue();
        color_purple();
        color_blue();
        color_red();
        color_green();
        color_blue();
    }
    divider = melody[thisNote + 1];
    if (divider > 0) {
      noteDuration = (wholenote) / divider;
    } else if (divider < 0) {
      noteDuration = (wholenote) / abs(divider);
      noteDuration *= 1.5;
    }
    tone(BUZZER_PIN, melody[thisNote], noteDuration * 0.9);
    delay(noteDuration);
    noTone(BUZZER_PIN);
    isMusic = 0;
  }
}


void setup() {
  Serial.begin(9600);
  pinMode(RED, OUTPUT); 
  pinMode(GREEN, OUTPUT); 
  pinMode(BLUE, OUTPUT); 
  pinMode(BUZZER_PIN, OUTPUT);

  // Connect to Wi-Fi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("Wi-Fi connected");
  Blynk.begin(BLYNK_AUTH_TOKEN, ssid, password);
}

void measureLight() {
  long sum = measureSound();
  int analogValue = analogRead(LIGHT_SENSOR_PIN);
  if (analogValue < 40 && sum > 50 && isMusic == 0) {
    Serial.println("DAR AND CRY");
    Blynk.logEvent("sound_alert", String("Baby crying in the dark"));
  } else if (analogValue > 40 && analogValue < 3200 && sum > 50 && isMusic == 0) {
    Blynk.logEvent("sound_alert", String("Baby crying"));
  } else if (analogValue > 3200) {
    Serial.println("LIGHT");
    Blynk.logEvent("light_alert", String("Too bright for baby to sleep"));
  }
  Blynk.virtualWrite(virtualPin, analogValue);
  delay(100); 
}

long measureSound() {
  long sum = 0;
  for(int i = 0; i < 300; i++) { 
    sum += analogRead(SOUND_SENSOR_PIN);
  }
  sum = sum/300; 

  Blynk.virtualWrite(virtualPinSound, sum);

  Serial.println("SOUND");
  Serial.print(sum);
  delay(100); 
  return sum;
}

void loop() {
  Blynk.run();
  measureLight();
  measureSound();
}

void color_red() {
  analogWrite(RED, 255);
  analogWrite(GREEN, 0);
  analogWrite(BLUE, 0);
}

void color_green() {
  analogWrite(RED, 0);
  analogWrite(GREEN, 255);
  analogWrite(BLUE, 0);
}

void color_blue() {
  analogWrite(RED, 0);
  analogWrite(GREEN, 0);
  analogWrite(BLUE, 255);
}

void color_purple() {
  analogWrite(RED, 255);
  analogWrite(GREEN, 0);
  analogWrite(BLUE, 255);
}

void color_light_green() {
  analogWrite(RED, 255);
  analogWrite(GREEN, 255);
  analogWrite(BLUE, 0);
}

void color_light_blue() {
  analogWrite(RED, 0);
  analogWrite(GREEN, 255);
  analogWrite(BLUE, 255);
}
